From c7971cea04f0a11e8d589f0c96ddc19ba73ed0fe Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 13:50:08 +0000
Subject: [PATCH 20/51] don't use modulemd for linting


The modulemd module trips over some errors. Instead, use the lower-level
YAML tree/dict throughout.

---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index f373450..9fcef32 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -3,8 +3,6 @@ from shutil import get_terminal_size
 
 from click.formatting import wrap_text
 
-import modulemd
-
 import yaml
 
 
@@ -113,8 +111,6 @@ class ModuleMDLinter(object):
             raise ValueError(
                 "specify exactly one of modulemd_path or modulemd_str")
 
-        mmd = self.mmd = modulemd.ModuleMetadata()
-
         self.modulemd_path = modulemd_path
 
         if not modulemd_str:
@@ -123,10 +119,9 @@ class ModuleMDLinter(object):
         else:
             self.modulemd_str = modulemd_str
 
-        mmd.loads(self.modulemd_str)
-
+        # We intentionally don't use the modulemd module for linting.
         self.yaml_doc = yaml.safe_load(self.modulemd_str)
-        self.yaml_data = self.yaml_doc['data']
+        self.mmd = self.yaml_doc['data']
 
     def lint(self, min_level=None):
         # ensure that min_level describes a valid level
@@ -227,7 +222,7 @@ class ModuleMDLinter(object):
     @guidelines_link('#Module_summary_and_description')
     def lint_summary_exists(self):
         """Every module MUST include a short summary."""
-        self.check(self.mmd.summary and self.mmd.summary.strip())
+        self.check(self.mmd.get('summary', "").strip())
 
     @error
     @guidelines_link('#Module_summary_and_description')
@@ -235,33 +230,34 @@ class ModuleMDLinter(object):
     def lint_summary_one_sentence(self):
         """The module summary is a one sentence concise description of the
         module."""
-        self.check("." not in self.mmd.summary[:-1])
+        self.check("." not in self.mmd['summary'][:-1])
 
     @warning
     @guidelines_link('#Module_summary_and_description')
     @prerequisite('summary_exists')
     def lint_summary_no_trailing_period(self):
         """The summary SHOULD NOT end in a period."""
-        self.check(not self.mmd.summary.strip().endswith("."))
+        self.check(not self.mmd['summary'].strip().endswith("."))
 
     @error
     @guidelines_link('#Module_summary_and_description')
     def lint_description_exists(self):
         """Every module MUST include a description."""
-        self.check(self.mmd.description and self.mmd.description.strip())
+        self.check(self.mmd['description']
+                   and self.mmd['description'].strip())
 
     @warning
     @guidelines_link('#Module_summary_and_description')
     @prerequisite('description_exists')
     def lint_description_ends_in_period(self):
         """The description SHOULD end in a period."""
-        self.check(self.mmd.description.strip().endswith("."))
+        self.check(self.mmd['description'].strip().endswith("."))
 
     @error
     @guidelines_link('#Module_licensing')
     def lint_license_block_exists(self):
         """Every module MUST contain a license block."""
-        self.check('license' in self.yaml_data)
+        self.check('license' in self.mmd)
 
     @error
     @guidelines_link('#Module_licensing')
@@ -271,7 +267,7 @@ class ModuleMDLinter(object):
     @prerequisite('license_block_exists')
     def lint_license_block_keys(self):
         """Every module MUST contain a license block."""
-        self.check_is_dict(self.yaml_data['license'])
+        self.check_is_dict(self.mmd['license'])
 
     @error
     @guidelines_link('#Module_licensing')
@@ -280,7 +276,7 @@ class ModuleMDLinter(object):
     def lint_license_module_block_exists(self):
         """Every module MUST contain a license block and declare a list of
         the module's licenses."""
-        self.check('module' in self.yaml_data['license'])
+        self.check('module' in self.mmd['license'])
 
     @error
     @guidelines_link('#Module_licensing')
@@ -289,7 +285,7 @@ class ModuleMDLinter(object):
     def lint_license_module_block_is_list(self):
         """Every module MUST contain a license block and declare a list of
         the module's licenses."""
-        self.check(isinstance(self.yaml_data['license']['module'], list))
+        self.check(isinstance(self.mmd['license']['module'], list))
 
     @error
     @guidelines_link(
@@ -298,15 +294,16 @@ class ModuleMDLinter(object):
         """Module packagers MUST NOT define values for name, stream, version,
         context or architecture manually but should rather expect the Module
         Build Service to do it for them."""
-        self.check_false(self.mmd.name or self.mmd.stream or self.mmd.version
-                         or self.mmd.context or self.mmd.arch)
+        self.check_false(
+            set(('name', 'stream', 'version', 'context', 'arch'))
+            & set(self.mmd))
 
     @error
     @guidelines_link('#Module_Service_Levels_and_End_of_Life')
     def lint_no_manual_eol(self):
         """Module packagers MUST NOT define the EOL in the modulemd but should
         define it in other infrastructure tooling."""
-        self.check_false(self.mmd.eol)
+        self.check_false('eol' in self.mmd)
 
     @error
     @guidelines_link('#Module_licensing')
@@ -314,8 +311,8 @@ class ModuleMDLinter(object):
     @prerequisite('license_block_keys')
     def lint_license_content(self):
         """The packager MAY also define a list of content licenses."""
-        if 'content' in self.yaml_data['license']:
-            self.check(isinstance(self.yaml_data['license']['content'], list))
+        if 'content' in self.mmd['license']:
+            self.check(isinstance(self.mmd['license']['content'], list))
 
     @error
     @guidelines_link('#Module_dependencies')
@@ -325,7 +322,7 @@ class ModuleMDLinter(object):
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
         if 'dependencies' in self.mmd:
-            self.check_is_dict(self.yaml_data['dependencies'])
+            self.check_is_dict(self.mmd['dependencies'])
 
     @error
     @guidelines_link('#Module_dependencies')
@@ -336,7 +333,7 @@ class ModuleMDLinter(object):
         """Modules MAY depend on other modules. These module relationships are
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
-        self.check_is_dict(self.yaml_data['dependencies']['buildrequires'])
+        self.check_is_dict(self.mmd['dependencies']['buildrequires'])
 
     @error
     @guidelines_link('#Module_dependencies')
@@ -347,7 +344,7 @@ class ModuleMDLinter(object):
         """Modules MAY depend on other modules. These module relationships are
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
-        for v in self.yaml_data['dependencies']['buildrequires'].values():
+        for v in self.mmd['dependencies']['buildrequires'].values():
             self.check_is_scalar(v)
 
     @error
@@ -359,7 +356,7 @@ class ModuleMDLinter(object):
         """Modules MAY depend on other modules. These module relationships are
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
-        self.check_is_dict(self.yaml_data['dependencies']['requires'])
+        self.check_is_dict(self.mmd['dependencies']['requires'])
 
     @error
     @guidelines_link('#Module_dependencies')
@@ -370,5 +367,5 @@ class ModuleMDLinter(object):
         """Modules MAY depend on other modules. These module relationships are
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
-        for v in self.yaml_data['dependencies']['requires'].values():
+        for v in self.mmd['dependencies']['requires'].values():
             self.check_is_scalar(v)

